#!/bin/env python

from netCDF4 import Dataset
from shapely.geometry import Point
from geopandas import GeoDataFrame
import geopandas
import matplotlib.pyplot as plt
import pandas as pd

l1b = Dataset('l1b_ref.nc')
l1c = Dataset('PACE_SPEXone.20220321T120000Z.L1C.5.2km.nc')
# l1c = Dataset('l1c_ref.nc')
target_viewport = 4

l1b_latitudes = l1b['GEOLOCATION_DATA/latitude'][:]
l1b_longitudes = l1b['GEOLOCATION_DATA/longitude'][:]
vp_indices = l1b['SENSOR_VIEW_BANDS/viewport_index']
l1b_latitudes = pd.DataFrame(l1b_latitudes, columns=vp_indices)
l1b_longitudes = pd.DataFrame(l1b_longitudes, columns=vp_indices)
l1b_longitudes = l1b_longitudes[target_viewport].to_numpy()
l1b_latitudes = l1b_latitudes[target_viewport].to_numpy()

l1c_latitudes = l1c['geolocation_data/latitude'][:]
l1c_longitudes = l1c['geolocation_data/longitude'][:]

world = geopandas.read_file(geopandas.datasets.get_path('naturalearth_lowres'))
l1b_geometry = [Point(xy) for xy in zip(l1b_longitudes.flatten(),
                                        l1b_latitudes.flatten())]
l1c_geometry = [Point(xy) for xy in zip(l1c_longitudes.flatten(),
                                        l1c_latitudes.flatten())]
gdf_l1b = GeoDataFrame(geometry=l1b_geometry, crs="EPSG:4326")
gdf_l1c = GeoDataFrame(geometry=l1c_geometry, crs="EPSG:4326")
ax = world.plot(color='lightblue')
gdf_l1b.plot(ax=ax, color='blue')
gdf_l1c.plot(ax=ax, color='red')

plt.show()
